﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class manip : MonoBehaviour
{
	public static manip _singleton;
	public Transform target;
	public Transform pov;
	public OVRPlayerController playerController;
	public RawImage controlsOverlay;
	public Texture manipTex;
	public Texture normalTex;
	public Transform playerHead;
	public Transform player;
	public float playerFlySpeed;

	public enum inputModes {NORMAL, MANIP};
	public inputModes inputMode;

	public enum manipModes {TRANSLATE, ROTATE};
	public manipModes manipMode;

	public GameObject cone;
	public GameObject cube;
	//public GameObject cylinder;
	private List<GameObject> ghosts;
	private bool cone_ghostdrawn = false;
	private bool cube_ghostdrawn = false;
	private bool cylinder_ghostdrawn = false;
	private bool overwriting = false;

	float translationSpeed = 1.5f;
	float rotationSpeed = 3.0f;
	Vector3 forward;
	Vector3 horizontal;
	float deadzone = 0.5f;

	Vector3 orig_pos;
	Vector3 orig_rot;

	public GameObject tl_obj;
	timeline_controller tl;

	public Text mode_text;

	void Awake ()
	{
		if (_singleton == null) {
			DontDestroyOnLoad(gameObject);
			_singleton = this;
		} else if (_singleton != this){
			Destroy(this);
		}
		inputMode = inputModes.NORMAL;
		manipMode = manipModes.TRANSLATE;

		tl = tl_obj.GetComponent<timeline_controller> ();
		ghosts = new List<GameObject> ();
	}

	void Start ()
	{

	}

	void Update ()
	{
		forward = pov.forward;
		horizontal = Vector3.Cross (forward, Vector3.up);

		ListenForXboxInput ();

		// Check if user is looking down
		if (playerHead.rotation.eulerAngles.x >= 45 && playerHead.rotation.eulerAngles.x <= 90) {
			controlsOverlay.enabled = true;
		} else {
			controlsOverlay.enabled = false;
		}
	}

	void ListenForXboxInput ()
	{
		float leftX = Input.GetAxis ("LJoyHorizontal");
		float leftY = -Input.GetAxis ("LJoyVertical");
		float rightY = -Input.GetAxis ("RJoyVertical");

		if (inputMode == inputModes.NORMAL) {
			if (Input.GetKeyUp(KeyCode.JoystickButton3)) {
				if (look_input._singleton.target != null) {
					target = look_input._singleton.target.transform;
					target.GetComponent<Renderer> ().material.color = Color.green;
					look_input._singleton.enabled = false;
					playerController.enabled = false;
					inputMode = inputModes.MANIP;
					orig_pos = new Vector3 (target.position.x, target.position.y, target.position.z);
					orig_rot = new Vector3 (target.eulerAngles.x, target.eulerAngles.y, target.eulerAngles.z);

					controlsOverlay.texture = (Texture)manipTex;

					if (tl.OnKeyframe())
						overwriting = true;

					if (manipMode == manipModes.TRANSLATE)
						mode_text.text = "Manipulate (Translate)";
					else
						mode_text.text = "Manipulate (Rotate)";
				}
			}

			if (Mathf.Abs(rightY) > deadzone) {
				player.position += (Vector3.up * rightY * playerFlySpeed);
			}

			if (player.position.y < 0.0f) {
				player.position = new Vector3(player.position.x, 0.0f, player.position.z);
			}

		} else if (inputMode == inputModes.MANIP) {
			if (manipMode == manipModes.TRANSLATE) {
				DoTranslation(leftX, leftY, rightY);

				if (Input.GetKeyUp(KeyCode.JoystickButton0)) {
					manipMode = manipModes.ROTATE;
					mode_text.text = "Manipulate (Rotate)";
				}
			}
			else if (manipMode == manipModes.ROTATE) {
				DoRotation(leftX, leftY, rightY);

				if (Input.GetKeyUp(KeyCode.JoystickButton0)) {
					manipMode = manipModes.TRANSLATE;
					mode_text.text = "Manipulate (Translate)";
				}
			}

			if (overwriting) {
				if (target.gameObject.name == "boy") {
					if (!cone_ghostdrawn) {
						if (target.position != orig_pos || target.eulerAngles != orig_rot) {
							// Draw ghost
							GameObject ghost = (GameObject)Instantiate (cone);
							ghost.transform.position = orig_pos;
							ghost.transform.eulerAngles = orig_rot;

							Material mat = ghost.GetComponent<MeshRenderer>().material;
							Color newcolor = Color.white;
							newcolor.a = 0.1f;
							mat.color = newcolor;

							ghost.GetComponent<MeshCollider>().enabled = false;

							cone_ghostdrawn = true;
							ghosts.Add(ghost);
						}
					}
				} else if (target.gameObject.name == "Stan_Lee") {
					if (!cube_ghostdrawn) {
						if (target.position != orig_pos || target.eulerAngles != orig_rot) {
							// Draw ghost
							GameObject ghost = (GameObject)Instantiate (cube);
							ghost.transform.position = orig_pos;
							ghost.transform.eulerAngles = orig_rot;
							
							Material mat = ghost.GetComponent<MeshRenderer>().material;
							Color newcolor = Color.white;
							newcolor.a = 0.1f;
							mat.color = newcolor;

							ghost.GetComponent<MeshCollider>().enabled = false;
							
							cube_ghostdrawn = true;
							ghosts.Add(ghost);
						}
					}
				} 
//				else if (target.gameObject.name == "Cylinder") {
//					if (!cylinder_ghostdrawn) {
//						if (target.position != orig_pos || target.eulerAngles != orig_rot) {
//							// Draw ghost
//							GameObject ghost = (GameObject)Instantiate (cylinder);
//							ghost.transform.position = orig_pos;
//							ghost.transform.eulerAngles = orig_rot;
//							
//							Material mat = ghost.GetComponent<MeshRenderer>().material;
//							Color newcolor = Color.white;
//							newcolor.a = 0.1f;
//							mat.color = newcolor;
//
//							ghost.GetComponent<CapsuleCollider>().enabled = false;
//							
//							cylinder_ghostdrawn = true;
//							ghosts.Add(ghost);
//						}
//					}
//				}
			}

			if (Input.GetKeyUp (KeyCode.JoystickButton2))
				target.position = orig_pos;

			if (Input.GetKeyUp (KeyCode.JoystickButton1))
				target.eulerAngles = orig_rot;

			if (Input.GetKeyUp (KeyCode.JoystickButton3)) {
				target.GetComponent<Renderer> ().material.color = Color.red;
				look_input._singleton.enabled = true;
				playerController.enabled = true;
				inputMode = inputModes.NORMAL;
				controlsOverlay.texture = (Texture)normalTex;
				overwriting = false;
				mode_text.text = "Navigate";
			}
		}
	}

	void DoTranslation (float x, float z, float y)
	{
		if (target != null) {

			// Move speed is proportional to object size so that object placement is easier.
			float moveCoefficient = Time.deltaTime * translationSpeed * Mathf.Sqrt(target.localScale.magnitude);

			if (Mathf.Abs(x) > deadzone)
				target.position += (-horizontal * x * moveCoefficient); 

			if (Mathf.Abs(y) > deadzone)
				target.position += (Vector3.up * y * moveCoefficient);
			
			if (Mathf.Abs(z) > deadzone) {
				target.position += (forward * z * moveCoefficient);
			}

			if (target.position.y < 0.0f)
				target.position = new Vector3(target.position.x, 0.0f, target.position.z);
		}
	}

	void DoRotation2 (bool x = false, bool b = false, bool y = false, bool a = false, float ldpad = 0.0f)
	{
		if (target != null) {
			if (x)
				target.Rotate (target.InverseTransformDirection (Vector3.up * rotationSpeed));

			if (b)
				target.Rotate (target.InverseTransformDirection (Vector3.up * -rotationSpeed));

			if (a)
				target.Rotate (target.InverseTransformDirection (Vector3.left * rotationSpeed));

			if (y)
				target.Rotate (target.InverseTransformDirection (Vector3.left * -rotationSpeed));

			if (Mathf.Abs(ldpad) > deadzone)
				target.Rotate (target.InverseTransformDirection (Vector3.forward * ldpad * rotationSpeed));
		}
	}

	void DoRotation (float x, float z, float y)
	{
		if (target != null) {			
			if (Mathf.Abs(x) > deadzone)
				target.Rotate (target.InverseTransformDirection (Vector3.up * x * rotationSpeed));
			
			if (Mathf.Abs(z) > deadzone)
				target.Rotate (target.InverseTransformDirection (Vector3.forward * z * rotationSpeed));
			
			if (Mathf.Abs(y) > deadzone) {
				target.Rotate (target.InverseTransformDirection (Vector3.left * -y * rotationSpeed));
			}

			if (target.position.y < 0.0f)
				target.position = new Vector3(target.position.x, 0.0f, target.position.z);
		}
	}

	public void ResetGhosts ()
	{
		if (ghosts.Count > 0) {
			for (int i = 0; i < ghosts.Count; i++) {
				Destroy(ghosts[i]);
			}
			cone_ghostdrawn = false;
			cube_ghostdrawn = false;
			cylinder_ghostdrawn = false;
		}
	}
}
